<script setup lang="ts">
  import { CustomerAddress } from '@shopware-pwa/types';
  import AccountAddressForm from '@/components/account/AccountAddressForm.vue';

  const emit = defineEmits<{
    (e: 'save', payload: CustomerAddress): void;
    (e: 'close'): void;
  }>();

  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
    address?: CustomerAddress;
  }>();

  const addressFormRef = ref<InstanceType<typeof AccountAddressForm>>();

  const saveChanges = async () => {
    const isValid = await addressFormRef.value?.validate();
    if (!isValid) return;

    const payload = addressFormRef.value?.state as CustomerAddress;
    if (props.address) {
      payload.id = props.address.id;
    }

    emit('save', addressFormRef.value?.state as CustomerAddress);
    emit('close');
  };
</script>

<template>
  <SwModal
    :modal-title="address ? $t('account.editAddress') : $t('account.addNewAddress')"
    :controller="controller"
    panel-class="md:min-w-[45rem]"
    backdrop-display="static"
  >
    <template #body>
      <AccountAddressForm ref="addressFormRef" :address="address" />
    </template>

    <template #footer>
      <SwButton variant="action" @click="$emit('close')">{{ $t('cancel') }}</SwButton>
      <SwButton @click="saveChanges">{{
        address ? $t('saveChanges') : $t('account.addAddress')
      }}</SwButton>
    </template>
  </SwModal>
</template>
